{% load i18n %}

{% block content %}

    <div class="jumbotron">
        <div class="row">
            <div class="col-xs-7">
                <h1>
                    {% trans "Assistente de Configuração" %}
                    <span id="deploy_id" class="label label-info">{% if request.session.deploy_id.0 %}ID:{{ request.session.deploy_id.0 }}{% endif %}{% if request.session.deploy_id.1 %}:{{ request.session.deploy_id.1 }}{% endif %}</span>
                </h1>
            </div>
            <div class="col-xs-5 text-right">
                <button id="btn_new" type="button" class="btn btn-default" data-toggle="tooltip" data-placement="bottom" title="{% trans 'Recomeçar, limpa todo o Assistente de Configuração' %}" {% if not request.session.last_step %} disabled="" {% endif %}>
                    <span class="glyphicon glyphicon-plus-sign"></span> <strong>{% trans "Novo Sistema" %}</strong>
                </button>
                <button id="btn_save" type="button" class="btn btn-primary" data-toggle="tooltip" data-placement="bottom" title="{% trans 'Guardar passos concluidos' %}" {% if not request.session.last_step or errors %} disabled="" {% endif %}>
                    <span class="glyphicon glyphicon-floppy-disk"></span> <strong>{% trans "Guardar" %}</strong>
                </button>
            </div>
        </div>

        {% include "wizard/steps.html" %}

    </div>
    {% include "front/modal/processing.html" %}

    <script type="text/javascript">
        // Tips global var
        var intro = introJs();

        var dname = null;

        var step7_check = false;
        // Save wizard state sessions from client-side
        $('#btn_save').click(function(e){
            {% if not request.session.deploy_id %}
            $("#inputname_form_error").html('');
            $('#divModal_inputname').modal('show');
            {% else %}
            // First disable button to prevent multiple calls
            $(this).attr('disabled', '');
            // Add some animation
            var btn = $(this);
            var btnlbl = btn.html();
            btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

            // Action on server-side
            $.ajax({
                type: 'GET',
                url: '{% url 'wizard:save_steps' step=0 %}',
                success: function(data) {
                    if (data["msg"]) {
                        $('#msg_str').html(data["msg"]);
                        if (data["deploy_id"]) {
                            $('#deploy_id').html(data["deploy_id"]);
                            {% if step == 8 %}
                            $('a.btn-default').each(function(){
                                $(this).attr('href', this.href.replace('/0/', '/' + data.deploy_id.replace('ID:', '') + '/'));
                            });
                            {% endif %}
                        }
                        $('#divModal_msg').modal('show');
                    }

                    // Reset button
                    btn.removeAttr('disabled');
                    btn.html(btnlbl);
                },
                error: function(e, x, r) {
                    console.log(r + ' - ' + e);
                    $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                    $('#divModal_msg').modal('show');

                    // Reset button
                    btn.removeAttr('disabled');
                    btn.html(btnlbl);
                }
            });
            e.preventDefault();
            {% endif %}
        });

        // On Document Ready
        $(function(){
            // Render Steps state
            var nrsteps = $(".bs-wizard-step").length + 1;

            for (i=1; i<nrsteps; i++) {
                if (i==step) {
                    $('#step'+i).removeClass('disabled');
                    $('#step'+i).addClass('active');
                    if (i<=last_step) $('#step'+i).addClass('completed');
                } else if (i<step || i<=last_step) {
                    $('#step'+i).removeClass('disabled');
                    $('#step'+i).addClass('complete');
                }
            }

            //activate next step
            $('#step'+(last_step+1)).removeClass('disabled');
            if (step < last_step+1) $('#step'+(last_step+1)).addClass('enabled');

            // Tips Settings
            {% if disclaimer %}
            intro.setOptions({
                steps: [{
                    intro: "{% trans 'Bem-vindo! Como é a sua primeira sessão siga este Assistente de Utilização' %}"
                  }, {
                    element: '#tips_btn',
                    intro: "{% trans 'Pode ativar estas ajudas, a partir deste botão, em qualquer momento e em qualquer passo' %}"
                  }, {
                    element: '#help_btn',
                    intro: "{% trans 'Todos os passos têm também este botão que expande um painel com informação adicional' %}"
                  }, {
                    element: '.bs-wizard',
                    intro: "{% trans 'A partir deste painel sabe sempre em que passo está e os que já concluiu, pode também usá-lo como menu de navegação' %}"
                  }, {
                    element: '#btn_new',
                    intro: "{% trans 'A partir do 2º passo pode recomeçar de novo, este botão limpa todo o Assistente de Configuração' %}"
                  }, {
                    element: '#btn_save',
                    intro: "{% trans 'A partir deste botão os passos concluidos são guardados, pode depois aceder ao Sistema a partir da página de Sistemas de Previsão' %}"
                  }, {
                    element: '#form_div',
                    intro: "{% trans 'Neste passo começe por preencher o formulário' %}"
                  }, {
                    element: '#btn_submit',
                    intro: "{% trans 'E prima o botão para continuar' %}"
                  }
                ],
                "nextLabel": " » ",
                "prevLabel": " « ",
                "skipLabel": " {% trans 'Fechar' %} ",
                "doneLabel": " {% trans 'Terminado' %} ",
                "disableInteraction": true,
                "tooltipPosition": "top"
            });
            {% else %}
            intro.setOptions({
                "nextLabel": " » ",
                "prevLabel": " « ",
                "skipLabel": " {% trans 'Fechar' %} ",
                "doneLabel": " {% trans 'Terminado' %} ",
                "disableInteraction": true,
                "tooltipPosition": "top"
            });
            {% endif %}

            $('#btn_name').click(function(e){
                // Validate form
                var name = $("input[name='inputname']").val();
                dname = name;   //save in global just in case we need it later
                if (!name) {
                    $("#inputname_form_error").html('{% trans "O campo é obrigatório." %}');
                } else {
                    // First disable button to prevent multiple calls
                    $(this).attr('disabled', '');
                    // Add some animation
                    var btn = $(this);
                    var btnlbl = btn.html();
                    btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}',
                        data: $('#inputname_form').serialize(),
                        success: function(data) {
                            $('#divModal_inputname').modal('hide');
                            $('#msg_str').html(data["msg"]);

                            if (data["deploy_id"]) {
                                $('#deploy_id').html(data["deploy_id"]);
                                {% if step == 8 %}
                                $('#id_name').val(dname);
                                $('a.btn-default').each(function(){
                                    $(this).attr('href', this.href.replace('/0/', '/' + data["deploy_id"].replace('ID:', '') + '/'));
                                });
                                {% endif %}
                            }
                            $('#divModal_msg').modal('show');

                            // Reset button
                            btn.removeAttr('disabled');
                            btn.html(btnlbl);
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $("#inputname_form_error").html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');

                            // Reset button
                            btn.removeAttr('disabled');
                            btn.html(btnlbl);
                        }
                    });
                }
                e.preventDefault();
            });

            // Button redirect page to previous step without validation
            $('#btn_prev').click(function(e){
                e.preventDefault();
                if (step != 0){ 
                    if (step == 8){
                    {% if "no" in wq_type %}
                        window.location.href = '/wizard/step' + (step-2);
                    {% else %}
                        window.location.href = '/wizard/step' + (step-1);
                    {% endif %}
                    }
                    else
                        window.location.href = '/wizard/step' + (step-1);
                }
            });

            // Button redirect page to next step without validation
            $('#btn_next').click(function(e){
                e.preventDefault();
                if (step != 0){
                    if (step == 6){
                    {% if "no" in wq_type %}
                        window.location.href = '/wizard/step' + (step+2);
                    {% else %}
                        window.location.href = '/wizard/step' + (step+1);
                    {% endif %}
                    }
                    else
                        window.location.href = '/wizard/step' + (step+1);

                    if (step == 7){
                        if (step7_check)
                            window.location.reload();
                    }
                }
            });

            // Button to restart step
            $('#btn_restart').click(function(e){
                e.preventDefault();
                if (step != 0) {
                    $('#exec_btn').on('click', function () {
                        window.location.href = '/wizard/step' + step + '/restart';
                    });

                    var message = '{% trans "Esta ação recomeça o Assistente de Configuração a partir deste passo, limpando-o bem como os posteriores. Se deseja manter a configuração atual prima Não." %}';
                    $('#cfm_tit').html('{% trans "Recomeçar" %}');
                    $('#cfm_str').html(message);               // Set message according to action
                    $('#divModal_confirm').modal();            // Show Confirm Modal
                 }
            });

            // New Deployment action
            $('#btn_new').click(function(e){
                if (last_step > 0) {
                    $('#exec_btn').on('click', function () {
                        // Validate server-side if user can create new deploy
                        //newdeploy("{% url 'front:new_deploy' %}", "{% url 'wizard:step1_restart' %}");
                        window.location.href = "{% url 'wizard:step1_restart' %}";
                    });

                    var message = '{% trans "O Assistente de Configuração será reiniciado. Se fez alterações à configuração atual e deseja mantê-las prima Não e guarde primeiro." %}';
                    $('#cfm_tit').html('{% trans "Recomeçar" %}');
                    $('#cfm_str').html(message);               // Set message according to action
                    $('#divModal_confirm').modal();            // Show Confirm Modal
                } else {
                    // Validate server-side if user can create new deploy
                    //newdeploy("{% url 'front:new_deploy' %}", "{% url 'wizard:step1_restart' %}");
                    window.location.href = "{% url 'wizard:step1_restart' %}";
                }
                e.preventDefault();
            });
        });
    </script>

{% endblock content %}
